
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 DeepPink
#property indicator_color4 Green
#property indicator_color5 Red
#property indicator_color6 clrGold
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_maximum 100
#property indicator_minimum 0
//---- input parameters
extern int Level = 291;   //    , 
extern int Ma    = 116; // 
extern int MaPeriod =206; 
extern int N =63;
extern int S =-53;
//---- buffers
double UpFrac[],UpFr[];
double DownFrac[],DFr[];
double ma[];
double BearsBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
    IndicatorBuffers(6);
   //---- indicator buffers mapping  
    SetIndexBuffer(0,UpFrac);
    SetIndexBuffer(1,DownFrac);
    SetIndexBuffer(2,ma);
    SetIndexBuffer(3,UpFr);
    SetIndexBuffer(4,DFr);
    SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,BearsBuffer); 
   //---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,217);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,218);
    SetIndexStyle(2,DRAW_NONE);
    SetIndexStyle(3,DRAW_ARROW);
    SetIndexArrow(3,233);
    SetIndexStyle(4,DRAW_ARROW);
    SetIndexArrow(4,234);
   //----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    SetIndexEmptyValue(3,0.0);
    SetIndexEmptyValue(4,0.0);
   //---- name for DataWindow
    SetIndexLabel(0,"Fractal Up");
    SetIndexLabel(1,"Fractal Down");
   
   //if(PriceOpen<0 || PriceOpen>1) PriceOpen=0;    
   //---- initialization done   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   //---- TODO: add your code here
   Comment("");
   //----
   return(0);
   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   int i,nCountedBars;
   double dCurrent;
   int j;
   double PriceFrac;
   double ama;
   nCountedBars=IndicatorCounted();
   //---- last counted bar will be recounted    
   i=Bars-nCountedBars+3;
   //----Up and Down Fractals
   while(i>=3)
      {
      //---- last Fractal    
      for (j=i; j<Bars; j++)
         {
         if(UpFrac[j]>0)
            {PriceFrac=UpFrac[j]; break;}
         if(DownFrac[j]>0)
            {PriceFrac=DownFrac[j]; break;}
         }
          ma[i]=iMA(NULL,0,Ma,0,0,1,i);
          BearsBuffer[i]=(Close[i]-iMA(NULL,0,MaPeriod,0,MODE_SMA,PRICE_CLOSE,i))*10000;  
      //----Fractals up

      dCurrent=High[i];ama = ma[i];
      if(dCurrent>High[i+1] && dCurrent>High[i-1])
         {
           if(MathAbs(dCurrent-PriceFrac)>=(Level*Point))
              {
              UpFrac[i]=dCurrent;
              }
              if(ama < ma[i+1]&&UpFrac[i]<ama&&BearsBuffer[i]>S)UpFr[i]=UpFrac[i];
         }
      //----Fractals down
      
      dCurrent=Low[i];
      if(dCurrent<Low[i+1] && dCurrent<Low[i-1])
            {
            if(MathAbs(dCurrent-PriceFrac)>=(Level*Point))
              {
              DownFrac[i]=dCurrent;
              }
              if(ama > ma[i+1]&&DownFrac[i]>ama&&BearsBuffer[i]<N)DFr[i]=DownFrac[i];
            }     

      i--;
      }
   //----
   return(0);
   }
//+------------------------------------------------------------------+